#include "stdafx.h"
#include <math.h>
#include <memory.h>
#include <stdlib.h>

float r_x = 0;
#define PI 3.14159265

#define DETAIL_ARO 20
#define DETAIL_NUMAROS 10
#define DETAIL_SIZE 20
#define MAX_SIZE 100.0f			// Mxim tamany del pop


float alpha = 0;
float alpha_inc = 0;
float theta = 0;
float theta_inc = 0;
float size = 0;
float size_inc = 0;

void InitRender (void)
{
	glPointSize(2);
	glLineWidth(2);
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	// Detall del pulpo
	alpha_inc = PI/(float)DETAIL_NUMAROS;
	theta_inc = 2*PI/(float)DETAIL_ARO;
	size_inc  = (float)MAX_SIZE/(float)DETAIL_SIZE;

}


float old_xrot = 0;
float old_yrot = 0;
float old_zrot = 0;

void DrawPulpo(int mag, float xrot, float yrot, float zrot)
{

	glColor4f(1,1,1,1);

	float x,y,z;
	float nx=0,ny=0,nz=0;	// New point values (after angle tarnsform)

	float dx,dy,dz;			// Diferencial de la rotaci (el que ens hem mogut respecte abans)
	dx = (xrot - old_xrot) * mag;
	dy = (yrot - old_yrot) * mag;
	dz = (zrot - old_zrot) * mag;

	old_xrot = xrot;
	old_yrot = yrot;
	old_zrot = zrot;


	// Dibuixem la esfera
	for (alpha=-PI/2; alpha<PI/2; alpha+=alpha_inc)
	{
		for (theta=0; theta<2*PI; theta+=theta_inc)
		{
			// Restore rotation angles
			xrot =	old_xrot;
			yrot =	old_yrot;
			zrot =	old_zrot;
			glBegin (GL_LINE_STRIP);//POINTS);
			for (size=1; size<MAX_SIZE; size+=size_inc)
			{
				glColor4f(1,0,0,1-size/MAX_SIZE);
				
				x = size*cos(alpha)*sin(theta);
				y = size*cos(alpha)*cos(theta);
				z = size*sin(alpha);
				///////////////////////////////////////
				// Process vertex rotations
				// X rot
				ny = (cos(xrot) * y) - (sin(xrot) * z);
				nz = (sin(xrot) * y) + (cos(xrot) * z);
				y = ny;
				z = nz;
				// Y rot
				nx = (cos(yrot) * x) + (sin(yrot) * z);
				nz = (cos(yrot) * z) - (sin(yrot) * x);
				x = nx;
				z = nz;
				// Z rot
				nx = (cos(zrot) * x) - (sin(zrot) * y);
				ny = (sin(zrot) * x) + (cos(zrot) * y);
				x = nx;
				y = ny;
				///////////////////////////////////////
				glVertex3f(x,y,z);
				
				xrot -= dx;		// Calcule next rotation angles...
				yrot -= dy;
				zrot -= dz;
			}
			glEnd();
		}
	}
}



void RenderObjects (void)
{
	r_x+=0.001f;
	glColor3f(1,0,0);

	glPushMatrix();
		glTranslatef(0,0,MAX_SIZE);
		//glRotatef(r_x*100, 1,1,1);
		glRotatef(90, 0,1,0);
		DrawPulpo(60, 2*sin(r_x), 2*sin(2*r_x), 2*sin(0.5*r_x));
		//DrawPulpo(60, 0,0,0);
		//DrawPulpo(0, 2*sin(r_x), 0);
		//DrawPulpo(0, 0, 2*sin(r_x));
		//DrawPulpo(2*sin(r_x), 2*sin(r_x), 2*sin(r_x));
		//DrawPulpo(0,0,0);

	glPopMatrix();
}