// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "render.h"

static float g_lightPos[4] = { 10, 10, -100, 1 };  // Position of light


void display(void)
{
   // Clear frame buffer and depth buffer
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   // Set up viewing transformation, looking down -Z axis
   glLoadIdentity();
   gluLookAt(0, 0, -3, 0, 0, -1, 0, 1, 0);

   // Set up the stationary light
   glLightfv(GL_LIGHT0, GL_POSITION, g_lightPos);

   // Render the scene
   RenderObjects();

   // Make sure changes appear onscreen
   glutSwapBuffers();
}



void reshape(GLint width, GLint height)
{
   glViewport(0, 0, width, height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(45.0, (float)width / width, 0.01f, 1000.0f);
   glMatrixMode(GL_MODELVIEW);
}

void InitGraphics(void)
{
   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);
   glShadeModel(GL_SMOOTH);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   InitRender();
}

int main(int argc, char* argv[])
{
	// GLUT Window Initialization:
	glutInit (&argc, argv);
	glutInitWindowSize (400, 400);
	glutInitDisplayMode ( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow ("xphere - My Little pulpo");

	// Initialize OpenGL graphics state
	InitGraphics();

	// Register callbacks:
	glutDisplayFunc (display);
	glutReshapeFunc (reshape);
	glutIdleFunc (display);//AnimateScene);


	// Turn the flow of control over to GLUT
	glutMainLoop ();

	return 0;
}

